#! /bin/sh
# -*- mode: sh; tab-width: 2; indent-tabs-mode: nil; coding: utf-8 -*-
# vim:shiftwidth=4:softtabstop=4:tabstop=4:
# SPDX-License-Identifier: GPL-2.0+

# Defaults
APPLICATION=pinball
PIDFILE=/var/run/${APPLICATION}.pid
BINFILE=/usr/bin/${APPLICATION}
SCRIPTNAME=/etc/init.d/${APPLICATION}

. /etc/init.d/functions

# echo "log: $@"

case "$1" in
    start)
        echo -n "Starting ${APPLICATION} service: "
        . /etc/profile
	      . "/etc/pinball/${APPLICATION}.env.sh"
	      export XDG_RUNTIME_DIR
        if [ ! -f "$PIDFILE" ]; then
            start-stop-daemon \
                --start --quiet --exec "$BINFILE" \
                -- --enable &> /dev/null
            start-stop-daemon \
                --start --quiet --pidfile "$PIDFILE" --exec "$BINFILE" -- \
                --record
            pidof "$BINFILE" > "$PIDFILE"
        fi
        sleep 10 # TODO
        [ -f "$PIDFILE" ] && echo "done." || echo "fail."
        [ -f "$PIDFILE" ] && echo "done." || echo "fail."

	      ;;

    stop)
        echo -n "Stoping ${APPLICATION} service: "
        if [ -f  "$PIDFILE" ] ; then
            start-stop-daemon \
                --stop --quiet --pidfile "$PIDFILE" --exec "$BINFILE" \
                -- --disable &> /dev/null
            killproc "$BINFILE"
            rm "$PIDFILE"
        fi
        [ ! -f "$PIDFILE" ] && echo "done." || echo "fail."
	      ;;

    restart)
        "$0" stop
        sleep 1
        "$0" start
	      ;;

    status)
        status "${APPLICATION}"
        ;;

    *)
        echo "Usage: $SCRIPTNAME {start|stop|restart|status}"
        exit 1
	      ;;
esac

exit 0
